;---------------------------------------
;	float ^ Z
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

; Z̐x	 Prbg
;		w Wrbg
;		 QSrbgixQTrbgj

; ʂA_[t[ꍇAє񐳋K͂OƂȂ܂
; I[o[t[ꍇ͖Ԃ܂

;
;	Z
;
	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___addsf3
___addsf3
	movem.l	4(sp),d0/d1

faddmain
	move.l	d3,a0
	move.l	d4,a1
;
;	wo
;
;	in:	d0.l	PxP
;		d1.l	PxQ
;
;	out:	d3.w	傫̎w
;		d4.w	w̍̐Βl
;
	move.w	#$7f80,d2	; get exponent
	move.l	d0,d3
	swap	d3
	and.w	d2,d3
	beq	returnD1exp
	move.l	d1,d4
	swap	d4
	and.w	d2,d4
	beq	returnD0

	move.w	d4,d2
	sub.w	d3,d4
	beq	getMantissa
	bpl	D4isPlus

	cmp.w	#$f180,d4	; d1 is underflow then d0
	bcs	returnD0
	neg.w	d4
	asr.w	#7,d4
	bra	getMantissa

D4isPlus
	cmp.w	#$0e80,d4	; d0 is underflow then d1
	bhi	returnD1
	move.w	d2,d3
	exg.l	d0,d1
	asr.w	#7,d4

;
;	o
;
;	in:	d0.l	PxP
;		d1.l	PxQ
;
;	out:	d0.l	PxP̉
;			0_00000_01.000000000000000000000000
;			^sign bit
;			         ^MSB of mantissa (economized bit)
;		d1.l	PxQ̉
;		d2.l	̃}XN
;
getMantissa
	move.l	#$007fffff,d2	; 00000000_1.00000000000000000000000
	tst.l	d1		; ^sign bit  ^mantissa(economized form)
	bmi	D1isMinus
	and.l	d2,d1
	bset	#23,d1
	add.l	d1,d1
	lsr.l	d4,d1
	bra	getD0mantissa
D1isMinus
	and.l	d2,d1
	bset	#23,d1
	add.l	d1,d1
	lsr.l	d4,d1
	neg.l	d1

getD0mantissa
	tst.l	d0
	bmi	D0isMinus
	and.l	d2,d0
	bset	#23,d0
	add.l	d0,d0
	bra	addMantissa
D0isMinus
	and.l	d2,d0
	bset	#23,d0
	add.l	d0,d0
	neg.l	d0

;
;	𑫂AK
;
;	in:	d0.l	PxP̉
;		d1.l	PxQ̉
;		d2.l	̃}XN
;
;	out:	d0.l	Px̉
;			 000000000_.00000000000000000000000
;			 ^sign bit  ^mantissa(economized form)

addMantissa
	add.l	d1,d0
	beq	returnZero
	move.l	d0,d4		; reserve sign bit
	bpl	Normalize
	neg.l	d0
;
;	K
;
Normalize
	swap	d0
	tst.w	d0
	bne	cmpHi16
;
;  0-15
;
cmpLow16
	swap	d0
	cmp.w	#$00ff,d0
	bhi	L16cmpbit12

	cmp.w	#$000f,d0
	bhi	Lcmpbit6
	cmp.w	#$0003,d0
	bhi	Ltstbit3

	cmp.w	#$0001,d0
	bhi	maxbit1
maxbit0
	bcs	returnD0
	moveq.l	#0,d0
	bset	#23,d0
	sub.w	#$0c00,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit1
	swap	d0
	lsl.l	#6,d0
	sub.w	#$0b80,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

Ltstbit3
	btst	#3,d0
	bne	maxbit3
maxbit2
	swap	d0
	lsl.l	#5,d0
	sub.w	#$0b00,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit3
	swap	d0
	lsl.l	#4,d0
	sub.w	#$0a80,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

Lcmpbit6
	cmp.w	#$003f,d0
	bhi	Ltstbit7

	btst	#5,d0
	bne	maxbit5
maxbit4
	swap	d0
	lsl.l	#3,d0
	sub.w	#$0a00,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit5
	swap	d0
	lsl.l	#2,d0
	sub.w	#$0980,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

Ltstbit7
	btst	#7,d0
	bne	maxbit7
maxbit6
	swap	d0
	add.l	d0,d0
	sub.w	#$0900,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit7
	swap	d0
	sub.w	#$0880,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

L16cmpbit12
	cmp.w	#$0fff,d0
	bhi	Lcmpbit14

	cmp.w	#$03ff,d0
	bhi	Ltstbit11

	btst	#9,d0
	bne	maxbit9
maxbit8
	swap	d0
	lsr.l	#1,d0
	sub.w	#$0800,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit9
	swap	d0
	lsr.l	#2,d0
	sub.w	#$0780,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

Ltstbit11
	btst	#11,d0
	bne	maxbit11
maxbit10
	swap	d0
	lsr.l	#3,d0
	sub.w	#$0700,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit11
	swap	d0
	lsr.l	#4,d0
	sub.w	#$0680,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

Lcmpbit14
	cmp.w	#$3fff,d0
	bhi	Ltstbit15

	btst	#13,d0
	bne	maxbit13
maxbit12
	swap	d0
	lsr.l	#5,d0
	sub.w	#$0600,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit13
	swap	d0
	lsr.l	#6,d0
	sub.w	#$0580,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

Ltstbit15
	tst.w	d0
	bmi	maxbit15
maxbit14
	swap	d0
	lsr.l	#7,d0
	sub.w	#$0500,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit15
	lsl.l	#8,d0
	sub.w	#$0480,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
;
; 16-31
;
cmpHi16
	cmp.w	#$00ff,d0
	bhi	H16cmpbit12

	cmp.w	#$000f,d0
	bhi	Hcmpbit6
	cmp.w	#$0003,d0
	bhi	Htstbit3

	btst	#1,d0
	bne	maxbit17
maxbit16
	swap	d0
	lsl.l	#7,d0
	sub.w	#$0400,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit17
	swap	d0
	lsl.l	#6,d0
	sub.w	#$0380,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

Htstbit3
	btst	#3,d0
	bne	maxbit19
maxbit18
	swap	d0
	lsl.l	#5,d0
	sub.w	#$0300,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit19
	swap	d0
	lsl.l	#4,d0
	sub.w	#$0280,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

Hcmpbit6
	cmp.w	#$003f,d0
	bhi	Htstbit7

	btst	#5,d0
	bne	maxbit21
maxbit20
	swap	d0
	lsl.l	#3,d0
	sub.w	#$0200,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit21
	swap	d0
	lsl.l	#2,d0
	sub.w	#$0180,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

Htstbit7
	btst	#7,d0
	bne	maxbit23
maxbit22
	swap	d0
	add.l	d0,d0
	sub.w	#$0100,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent
maxbit23
	swap	d0
	sub.w	#$0080,d3
	bls	returnZero	; under flow (or denormalized)
	bra	setExponent

H16cmpbit12
	btst	#9,d0
	bne	maxbit25
maxbit24
	swap	d0
	lsr.l	#1,d0
	bra	setExponent
maxbit25
	swap	d0
	lsr.l	#2,d0
	add.w	#$0080,d3
	bmi	returnINF	; over flow
	bra	setExponent

;
;	ƎwƉ
;
;	in:	d0.l	
;		d2.l	̃}XN
;		d3.w	w
;
setExponent
	and.l	d2,d0
	swap	d0
	or.w	d3,d0
	swap	d0

	tst.l	d4
	bpl	returnD0

	bset	#31,d0
	move.l	a1,d4
	move.l	a0,d3
	rts

;
;	Z
;
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___subsf3
___subsf3
	movem.l	4(sp),d0/d1

	bchg	#31,d1
	bra	faddmain

;
;	̑
;
returnD1exp
	move.l	d1,d0
	swap	d1
	and.w	#$7f80,d1
	beq	returnZero

	move.l	a1,d4
	move.l	a0,d3
	rts

returnD1
	move.l	d1,d0

returnD0
	move.l	a1,d4
	move.l	a0,d3
	rts

returnZero
	moveq.l	#0,d0
	move.l	a1,d4
	move.l	a0,d3
	rts

returnINF
	move.l	#$ff000000,d0
	add.l	d4,d4
	roxr.l	#1,d0		; set sign bit
	move.l	a1,d4
	move.l	a0,d3
	rts
