;---------------------------------------
;	long long ^ ZpEVtg
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___ashrdi3
___ashrdi3
	movem.l	4(sp),d0/d1/d2

	cmp.w	#2,d2
	bhi	rightSft3
	beq	rightSft2

rightSft1
	tst.w	d2		* for 0 bit shift
	beq.s	rightSft0	*
	asr.l	#1,d1
	roxr.l	#1,d0
rightSft0
	rts

rightSft2
	asr.l	#1,d1
	roxr.l	#1,d0
	asr.l	#1,d1
	roxr.l	#1,d0
	rts

rightSft3		;80+6n
	cmp.w	#16,d2
	bhi	rightSft17
	beq	rightSft16

	move.l	d3,a0		; save register
	move.l	d0,d3		; 1:2:3:4 -> d1=1:2 d3=2:3 d0=3:4
	move.w	d1,d3
	swap	d3

	asr.l	d2,d1		; right left 1:2
	lsr.l	d2,d3		; right left 2:3
	lsr.l	d2,d0		; right left 3:4

	swap	d0		; d1=1:2 d0=3:4
	move.w	d3,d0
	swap	d0
	move.l	a0,d3		; restore register
	rts			*bra	returnD1D0

rightSft16
	move.w	d1,d0		; 1:2:3:4 -> d1=?:1 d0=2:3
	swap	d0
	swap	d1		*move.l	d1,d2
	ext.l	d1		*add.l	d2,d2
				*subx.w	d1,d1
				*swap	d1
	rts			*bra	returnD1D0

rightSft17
	cmp.w	#32,d2
	bhi	rightSft33
	beq	rightSft32

	move.w	d1,d0		; 1:2:3:4 -> d1=1:2 d0=2:3
	swap	d0

	sub.w	#16,d2
	asr.l	d2,d1
	lsr.l	d2,d0

	swap	d0		; d1=1:2 d0=2:3 -> d1=0:1 d0=2:3
	move.w	d1,d0
	swap	d0
	swap	d1		*move.l	d1,d2
	ext.l	d1		*add.l	d2,d2
				*subx.w	d1,d1
				*swap	d1
	rts			*bra	returnD1D0

rightSft32
	move.l	d1,d0
	add.l	d1,d1
	subx.l	d1,d1
	rts			*bra	returnD1D0

rightSft33
	move.l	d1,d0
	sub.w	#32,d2
	asr.l	d2,d0
	add.l	d1,d1
	subx.l	d1,d1

returnD1D0
	rts

