.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.xref	___mulsi3
	.xref	_free

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.globl	___builtin_delete
___builtin_delete:
	move.l	4(sp),d0
	beq	l4
	move.l	d0,-(sp)
.if	ALL_BSR
	bsr	_free
.else
	jsr	_free
.endif
	addq.l	#4,sp
l4:
	rts

.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.globl	___builtin_vec_delete
___builtin_vec_delete:
	link	a6,#-12
	move.l	12(a6),d0
	addq.l	#1,d0
	move.l	d0,-8(a6)
	move.l	8(a6),-12(a6)
.if	MPU>=68020
	move.l	-8(a6),d0
	mulu.l	16(a6),d0
.else
	move.l	-8(a6),-(sp)
	move.l	16(a6),-(sp)
.if	ALL_BSR
	bsr	___mulsi3
.else
	jsr	___mulsi3
.endif
*	move.l	-8(a6),d0
*	move.l	16(a6),d1
*	movem.l	d0/d1,-(sp)
*	fpack	__CLMUL
*	movem.l	(sp)+,d0/d1
.endif
	add.l	d0,8(a6)
	clr.l	-4(a6)
	bra	l8
l20001:
	move.l	16(a6),d0
	sub.l	d0,8(a6)
	move.l	28(a6),-(sp)
	move.l	8(a6),-(sp)
	move.l	20(a6),d0
	move.l	d0,a0
	jsr	(a0)
	addq.l	#8,sp
l10:
	addq.l	#1,-4(a6)
l8:
	move.l	-4(a6),d0
	cmp.l	-8(a6),d0
	blt	l20001
	move.l	24(a6),d0
	beq	l11
	move.l	-12(a6),-(sp)
.if	ALL_BSR
	bsr	_free
.else
	jsr	_free
.endif
	addq.l	#4,sp
l11:
	unlk	a6
	rts
