*---------------------------------------
*	double ^ r
*---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.offset	4
Q0h	.ds.l	1
Q0l	.ds.l	1
Q1h	.ds.l	1
Q1l	.ds.l	1

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___cmpdf2
___cmpdf2
	move.l	Q0h(sp),d0
	bmi.s	Q0isMinus
Q0isPlus:
	move.l	Q1h(sp),d1
	bmi.s	Q0isHigh_Check0
Q0Q1isPlus:
	sub.l	d1,d0
	bne.s	Q0Q1isPlus_end
Q0Q1isPlus_HighEqu
	move.l	Q0l(sp),d0
	sub.l	Q1l(sp),d0
	bhi.s	Q0isHigh
	bcs	Q0isLow
Q0Q1isPlus_end:
	rts

Q0isMinus
	move.l	Q1h(sp),d1
	bpl.s	Q0isLow_Check0
Q0Q1isMinus:
	sub.l	d1,d0
	beq.s	Q0Q1isMinus_HighEqu
	neg.l	d0
	rts

Q0Q1isMinus_HighEqu:
	move.l	Q0l(sp),d0
	sub.l	Q1l(sp),d0
	bhi.s	Q0isLow
	bcs.s	Q0isHigh
	rts

Q0isHigh_Check0:		* d0=Q0h >= 0, d1=Q0h < 0
	bclr.l	#31,d1		* clear sign bit
	or.l	d1,d0		* check +0.0, -0.0
	bne.s	Q0isHigh
	move.l	Q0l(sp),d0
	or.l	Q1l(sp),d0
	beq.s	Q0isHigh_end
Q0isHigh
	moveq.l	#1,d0
Q0isHigh_end:
	rts

Q0isLow_Check0:			* d0=Q0h < 0, d1=Q0h >= 0
	bclr.l	#31,d0		* clear sign bit
	or.l	d1,d0		* check +0.0, -0.0
	bne.s	Q0isLow
	move.l	Q0l(sp),d0
	or.l	Q1l(sp),d0
	beq.s	Q0isLow_end
Q0isLow
	moveq.l	#-1,d0
Q0isLow_end:
	rts
