;
;	src/cmpdi1.s: part of libgnu-1.50
;	Copyright 1994  씎Y(oo), HGG00736@niftyserve.or.jp
;
*---------------------------------------
*	long long ^ r
*---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___ucmpdi1
___ucmpdi1:
	movem.l	4(sp),d0/d1/d2/a0
	cmp.l	a0,d1
	bhi.s	___cmpdi1_greater
	bcs.s	___cmpdi1_less
	sub.l	d2,d0
	bhi.s	___cmpdi1_greater
	bcs.s	___cmpdi1_less
	rts

.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___cmpdi1
___cmpdi1:
	movem.l	4(sp),d0/d1/d2/a0
	cmp.l	a0,d1
	bgt.s	___cmpdi1_greater
	blt.s	___cmpdi1_less
	sub.l	d2,d0
	bhi.s	___cmpdi1_greater
	bcs.s	___cmpdi1_less
	rts
___cmpdi1_greater:
	moveq.l	#1,d0
	rts
___cmpdi1_less:
	moveq.l	#-1,d0
	rts

