;---------------------------------------
;	float ^ r
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___cmpsf2
___cmpsf2
	move.l	4(sp),d0
	bmi	D0isMinus	; Sign bit is 1
D0isPlus
	move.l	8(sp),d1
	bmi	D1isMinus	; Sign bit is 1
D1isPlus
	sub.l	d1,d0
	rts

D0isMinus
	bclr.l	#31,d0
	move.l	8(sp),d1
	bmi	D0D1isMinus

	; d0 is lower or equal then Zero
	; d1 is higher or equal then Zero
	or.l	d1,d0		; if d0 and d1 euqal Zero then return Zero
	neg.l	d0		; else return Minus Number (d0 < d1)
	rts

D1isMinus
	; d0 is higher or equal then Zero
	; d1 is lower or equal then Zero
	bclr.l	#31,d1
	or.l	d1,d0		; if d0 and d1 equal Zero then return Zero
	rts			; else return Plus Number (d0 > d1)

D0D1isMinus
	bclr.l	#31,d1
	sub.l	d1,d0
	neg.l	d0
	rts
