;---------------------------------------
;	float ^ Z
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

; Z̐x	 Prbg
;		w Wrbg
;		 QSrbgixRPrbgj

; 񐳋KAꐔɂ͑ΉĂ܂
; ʂA_[t[ꍇ͂OA
; I[o[t[ꍇ͕rbgȊO͑SrbgPɂȂ܂

;
;	Z
;

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___divsf3
___divsf3
	movem.l	4(sp),d0/d1

	move.l	d3,a0
	move.l	d4,a1
;
;	wo
;
;	in:	d0.l	PxP
;		d1.l	PxQ
;
;	out:	d3.w	P̎wioCAX܂ށj
;		d4.w	Q̎wioCAX܂ށj
;
	move.w	#$7f80,d2
	move.l	d1,d4
	swap	d4
	and.w	d2,d4
	beq	returnNAN	; devide by Zero
	move.l	d0,d3
	swap	d3
	and.w	d2,d3
	beq	returnZero	; devide Zero
;
;	wvZ
;
;	in:	d3.w	wPioCAX܂ށj
;		d4.w	wQioCAX܂ށj
;
;	out:	d3.w	w̍ioCAX܂ށj
;		d4.l	id4.l ̕rbgj
;
	sub.w	d4,d3
	add.w	#$3f80,d3	; add exponent bias
	blt	returnZero	; exponent under flow (N and !V)

	move.l	d0,d4		; reserve sign bit
	eor.l	d1,d4
;
;	o
;
;	in:	d0.l	PxP
;		d1.l	PxQ
;
;	out:	d0.l	P̉
;			 01.000000000000000000000000000000
;		d1.l	Q̉
;			 1.0000000000000000000000000000000
;
	move.l	#$007fffff,d2
	and.l	d2,d0
	lsl.l	#7,d0
	bset	#30,d0

	and.l	d2,d1
	lsl.l	#8,d1
	bset	#31,d1
;
;	vZ
;
	move.l	d5,a2
	move.l	d0,d5
	swap	d5
	mulu.w	d1,d5		; B * a			... step 1
	swap	d1
	divu.w	d1,d5		; (B * a) / b		... step 2
	and.l	#$0000ffff,d5
	sub.l	d5,d0		; BA - (B * a) / b	... step 3
	divu.w	d1,d0		; step3 / b		... step 4
	move.l	d0,d5
	clr.w	d5
	divu.w	d1,d5		; step 3 ̗]ʃ[hɂ b Ŋ
	swap	d0
	move.w	d5,d0		; step 3 ̏ʃ[hɂ
	move.l	a2,d5
;
;	𐳋K
;
	moveq.l	#0,d1
	tst.l	d0
	bmi	rightSft8bit

	sub.w	#$0080,d3	; rightSft7bit
	bls	returnZero	; exponent under flow (or denormalized)
	bmi	returnINF	; exponent over flow
	lsr.l	#7,d0
	bra	setExponent

rightSft8bit
	tst.w	d3
	beq	returnZero	; denormalized
	bmi	returnINF	; exponent over flow
	lsr.l	#8,d0
;
;	ƎwƉ̍
;
setExponent
	and.l	d2,d0
	swap	d0
	or.w	d3,d0
	swap	d0

	tst.l	d4
	bpl	returnD0
	bset	#31,d0		; set sign bit
returnD0
	move.l	a1,d4
	move.l	a0,d3
	rts

;
;	̑
;
returnNAN
	move.l	#$7fffffff,d0
	move.l	a1,d4
	move.l	a0,d3
	rts

returnINF
	move.l	#$ff000000,d0
	add.l	d4,d4
	roxr.l	#1,d0
	move.l	a1,d4
	move.l	a0,d3
	rts

returnZero
	moveq.l	#0,d0
	move.l	a1,d4
	move.l	a0,d3
	rts
