;---------------------------------------
;	float  double ^ϊ
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

; ʂA_[t[ꍇAє񐳋K͂OƂȂ܂
; I[o[t[ꍇ͖Ԃ܂
; 񐔂̏ꍇ͔񐔂Ԃ܂

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___extendsfdf2
___extendsfdf2
	move.l	4(sp),d0
	move.l	d0,d1
	beq.s	return
	swap	d1
	and.w	#$7f80,d1
	beq	returnZero	; is Zero (Minus Zero) or unnormalized number
	cmp.w	#$7f80,d1
	beq	returnNanInf	; is NAN or INF
;
;	ʃ[h̊g
;
	move.l	d0,d1
	asr.l	#3,d0		; shift bits
	swap	d0
	and.w	#$8fff,d0	; 1000_1111_1111_1111 sign bit and other
	add.w	#$3800,d0	; add exponent bias ($3FF0-$07F0)
	swap	d0
;
;	ʃ[h̊g
;
	ror.l	#3,d1
	and.l	#$e0000000,d1
return:
	rts

returnZero
	moveq.l	#0,d0
	move.l	d0,d1
	rts

returnNanInf
	move.l	d0,d1
	and.l	#$007fffff,d1
	bne	returnNAN

returnINF
	or.l	#$7ff00000,d0
	moveq.l	#0,d1		*	moveq.l	#0,d0
	rts

returnNAN
	or.l	#$7fffffff,d0
	moveq.l	#-1,d1
	rts
