;---------------------------------------
;      long long  double ^ϊ
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___floatdidf
___floatdidf
	move.l	4(sp),d1
	move.l	8(sp),d0
	move.l	d0,a0		; reserve sign bit
	bpl	Normalize
	neg.l	d1
	negx.l	d0

Normalize
	tst.l	d0
	bne	cmpHi32
;
;@ŏʃrbgO`RP̏ꍇ
;
	swap	d1
	tst.w	d1
	bne	cmpLow32Hi16
;
;  bit 0-15
;
cmpLow32Low16
	swap	d1
	cmp.w	#$00ff,d1
	bhi	LL16cmpbit12

	cmp.w	#$000f,d1
	bhi	LLcmpbit6
	cmp.w	#$0003,d1
	bhi	LLtstbit3

	cmp.w	#$0001,d1
	bhi	maxbit1
maxbit0
	bcs	returnD0D1	; is Zero
	moveq.l	#0,d1		; is 1
	move.l	#$3ff00000,d0
	bra	setSignFlag
maxbit1
	exg.l	d1,d0
	lsl.w	#3,d0
	and.w	#$000f,d0
	or.w	#$4000,d0
	swap	d0
	bra	setSignFlag

LLtstbit3
	btst	#3,d1
	bne	maxbit3
maxbit2
	exg.l	d1,d0
	lsl.w	#2,d0
	or.w	#$4010,d0
	swap	d0
	bra	setSignFlag
maxbit3
	exg.l	d1,d0
	add.w	d0,d0
	and.w	#$000f,d0
	or.w	#$4020,d0
	swap	d0
	bra	setSignFlag

LLcmpbit6
	cmp.w	#$003f,d1
	bhi	LLtstbit7

	btst	#5,d1
	bne	maxbit5
maxbit4
	exg.l	d1,d0
	or.w	#$4030,d0
	swap	d0
	bra	setSignFlag
maxbit5
	exg.l	d1,d0
	and.w	#$001f,d0
	or.w	#$8080,d0	;404
	swap	d0
	lsr.l	#1,d0
	bra	setSignFlag

LLtstbit7
	btst	#7,d1
	bne	maxbit7
maxbit6
	exg.l	d1,d0
	ror.l	#2,d0
	or.w	#$4050,d0
	swap	d0
	bra	setSignFlag
maxbit7
	exg.l	d1,d0
	ror.l	#3,d0
	and.w	#$000f,d0
	or.w	#$4060,d0
	swap	d0
	bra	setSignFlag

LL16cmpbit12
	cmp.w	#$0fff,d1
	bhi	LLcmpbit14

	cmp.w	#$03ff,d1
	bhi	LLtstbit11

	btst	#9,d1
	bne	maxbit9
maxbit8
	exg.l	d1,d0
	ror.l	#4,d0
	or.w	#$4070,d0
	swap	d0
	bra	setSignFlag
maxbit9
	exg.l	d1,d0
	ror.l	#5,d0
	and.w	#$000f,d0
	or.w	#$4080,d0
	swap	d0
	bra	setSignFlag

LLtstbit11
	btst	#11,d1
	bne	maxbit11
maxbit10
	exg.l	d1,d0
	ror.l	#6,d0
	or.w	#$4090,d0
	swap	d0
	bra	setSignFlag
maxbit11
	exg.l	d1,d0
	ror.l	#7,d0
	and.w	#$000f,d0
	or.w	#$40a0,d0
	swap	d0
	bra	setSignFlag

LLcmpbit14
	cmp.w	#$3fff,d1
	bhi	LLtstbit15

	btst	#13,d1
	bne	maxbit13
maxbit12
	exg.l	d1,d0
	ror.l	#8,d0
	or.w	#$40b0,d0
	swap	d0
	bra	setSignFlag
maxbit13
	exg.l	d1,d0
	lsl.l	#7,d0
	swap	d0
	and.w	#$000f,d0
	or.w	#$40c0,d0
	swap	d0
	bra	setSignFlag

LLtstbit15
	tst.w	d1
	bmi	maxbit15
maxbit14
	exg.l	d1,d0
	lsl.l	#6,d0
	swap	d0
	or.w	#$40d0,d0
	swap	d0
	bra	setSignFlag
maxbit15
	exg.l	d1,d0
	lsl.l	#5,d0
	swap	d0
	and.w	#$000f,d0
	or.w	#$40e0,d0
	swap	d0
	bra	setSignFlag
;
; 16-31
;
cmpLow32Hi16
	cmp.w	#$00ff,d1
	bhi	LH16cmpbit12

	cmp.w	#$000f,d1
	bhi	LHcmpbit6
	cmp.w	#$0003,d1
	bhi	LHtstbit3

	btst	#1,d1
	bne	maxbit17
maxbit16
	exg.l	d1,d0
	move.w	#$040f,d0
	swap	d0
	lsl.l	#4,d0
	bra	setSignFlag
maxbit17
	exg.l	d1,d0
	rol.l	#3,d0
	and.w	#$000f,d0
	or.w	#$4100,d0
	swap	d0
	bra	setSignFlag

LHtstbit3
	btst	#3,d1
	bne	maxbit19
maxbit18
	exg.l	d1,d0
	rol.l	#2,d0
	or.w	#$4110,d0
	swap	d0
	bra	setSignFlag
maxbit19
	exg.l	d1,d0
	rol.l	#1,d0
	and.w	#$000f,d0
	or.w	#$4120,d0
	swap	d0
	bra	setSignFlag

LHcmpbit6
	cmp.w	#$003f,d1
	bhi	LHtstbit7

	btst	#5,d1
	bne	maxbit21
maxbit20
	exg.l	d1,d0
	or.w	#$4130,d0
	swap	d0
	bra	setSignFlag
maxbit21
	exg.l	d1,d0
	and.w	#$001f,d0
	or.w	#$8280,d0	;414
	swap	d0
	lsr.l	#1,d0
	roxr.l	#1,d1
	bra	setSignFlag

LHtstbit7
	btst	#7,d1
	bne	maxbit23
maxbit22
	ror.l	#2,d1
	move.b	d1,d0
	or.w	#$4150,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit23
	ror.l	#3,d1
	move.b	d1,d0
	and.w	#$000f,d0
	or.w	#$4160,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag

LH16cmpbit12
	cmp.w	#$0fff,d1
	bhi	LHcmpbit14

	cmp.w	#$03ff,d1
	bhi	LHtstbit11

	btst	#9,d1
	bne	maxbit25
maxbit24
	ror.l	#4,d1
	move.b	d1,d0
	or.w	#$4170,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit25
	ror.l	#5,d1
	move.b	d1,d0
	and.w	#$000f,d0
	or.w	#$4180,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag

LHtstbit11
	btst	#11,d1
	bne	maxbit27
maxbit26
	ror.l	#6,d1
	move.b	d1,d0
	or.w	#$4190,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit27
	ror.l	#7,d1
	move.b	d1,d0
	and.w	#$000f,d0
	or.w	#$41a0,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag

LHcmpbit14
	cmp.w	#$3fff,d1
	bhi	LHtstbit15

	btst	#13,d1
	bne	maxbit29
maxbit28
	ror.l	#8,d1
	move.b	d1,d0
	or.w	#$41b0,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit29
	swap	d1
	rol.l	#7,d1
	move.l	d1,d0
	and.w	#$ff80,d1
	and.w	#$000f,d0
	or.w	#$41c0,d0
	swap	d0
	swap	d1
	clr.w	d1
	bra	setSignFlag

LHtstbit15
	tst.w	d1
	bmi	maxbit31
maxbit30
	swap	d1
	rol.l	#6,d1
	move.l	d1,d0
	and.w	#$ffc0,d1
	and.w	#$000f,d0
	or.w	#$41d0,d0
	swap	d0
	swap	d1
	clr.w	d1
	bra	setSignFlag
maxbit31
	swap	d1
	rol.l	#5,d1
	move.l	d1,d0
	and.w	#$ffe0,d1
	and.w	#$000f,d0
	or.w	#$41e0,d0
	swap	d0
	swap	d1
	clr.w	d1
	bra	setSignFlag
;
;@ŏʃrbgRQ`UȐꍇ
;
cmpHi32
	swap	d0
	tst.w	d0
	bne	cmpHi32Hi16
;
;  bit 32-47
;
cmpHi32Low16
	swap	d0
	cmp.w	#$00ff,d0
	bhi	HL16cmpbit12
	cmp.w	#$000f,d0
	bhi	HLcmpbit6
	cmp.w	#$0003,d0
	bhi	HLtstbit3

	btst	#1,d0
	bne	maxbit33
maxbit32
	rol.l	#4,d1
	move.l	d1,d0
	move.w	#$41f0,d0
	or.b	d1,d0
	and.w	#$fff0,d1
	swap	d0
	swap	d1
	clr.w	d1
	bra	setSignFlag
maxbit33
	move.l	d1,d2
	move.w	d0,d2
	rol.l	#3,d2
	lsl.l	#3,d1
	move.l	d1,d0
	move.w	d2,d0
	and.w	#$000f,d0
	or.w	#$4200,d0
	swap	d0
	swap	d1
	clr.w	d1
	bra	setSignFlag

HLtstbit3
	btst	#3,d0
	bne	maxbit35
maxbit34
	add.l	d1,d1
	addx.l	d0,d0
	add.l	d1,d1
	addx.l	d0,d0
	or.w	#$4210,d0
	swap	d0
	swap	d1
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit35
	add.l	d1,d1
	addx.l	d0,d0
	and.w	#$000f,d0
	or.w	#$4220,d0
	swap	d0
	swap	d1
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag

HLcmpbit6
	cmp.w	#$003f,d0
	bhi	HLtstbit7

	btst	#5,d0
	bne	maxbit37
maxbit36
	or.w	#$4230,d0
	swap	d0
	swap	d1
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit37
	and.w	#$001f,d0
	or.w	#$8480,d0	;424
	swap	d0
	swap	d1
	move.w	d1,d0
	clr.w	d1
	lsr.l	#1,d0
	roxr.l	#1,d1
	bra	setSignFlag

HLtstbit7
	btst	#7,d0
	bne	maxbit39
maxbit38
	swap	d0
	swap	d1
	move.w	d1,d0
	swap	d1
	lsr.l	#2,d0
	ror.l	#2,d1
	swap	d1
	and.w	#$c000,d1
	swap	d0
	or.w	#$4250,d0
	swap	d0
	bra	setSignFlag
maxbit39
	swap	d0	;56
	swap	d1
	move.w	d1,d0
	swap	d1
	lsr.l	#3,d0
	ror.l	#3,d1
	swap	d1
	and.w	#$e000,d1
	swap	d0
	and.w	#$000f,d0
	or.w	#$4260,d0
	swap	d0
	bra	setSignFlag

HL16cmpbit12
	cmp.w	#$0fff,d0
	bhi	HLcmpbit14

	cmp.w	#$03ff,d0
	bhi	HLtstbit11

	btst	#9,d0
	bne	maxbit41
maxbit40
	swap	d0	;60
	swap	d1
	move.w	d1,d0
	swap	d1
	lsr.l	#4,d0
	ror.l	#4,d1
	swap	d1
	and.w	#$f000,d1
	swap	d0
	or.w	#$4270,d0
	swap	d0
	bra	setSignFlag
maxbit41
	swap	d0	;64
	swap	d1
	move.w	d1,d0
	swap	d1
	lsr.l	#5,d0
	ror.l	#5,d1
	swap	d1
	and.w	#$f800,d1
	swap	d0
	and.w	#$000f,d0
	or.w	#$4280,d0
	swap	d0
	bra	setSignFlag

HLtstbit11
	btst	#11,d0
	bne	maxbit43
maxbit42
	swap	d0	;68
	swap	d1
	move.w	d1,d0
	swap	d1
	lsr.l	#6,d0
	ror.l	#6,d1
	swap	d1
	and.w	#$fc00,d1
	swap	d0
	or.w	#$4290,d0
	swap	d0
	bra	setSignFlag
maxbit43
	swap	d0	;72
	swap	d1
	move.w	d1,d0
	swap	d1
	lsr.l	#7,d0
	ror.l	#7,d1
	swap	d1
	and.w	#$fe00,d1
	swap	d0
	and.w	#$000f,d0
	or.w	#$42a0,d0
	swap	d0
	bra	setSignFlag

HLcmpbit14
	cmp.w	#$3fff,d0
	bhi	HLtstbit15

	btst	#13,d0
	bne	maxbit45
maxbit44
	lsl.l	#8,d0	;56
	rol.l	#8,d1
	move.b	d1,d0
	clr.b	d1
	swap	d0
	or.w	#$42b0,d0
	swap	d0
	bra	setSignFlag
maxbit45
	lsl.l	#7,d0	; 68
	rol.l	#7,d1
	move.w	d1,d2
	and.w	#$ff80,d1
	and.w	#$007f,d2
	or.w	d2,d0
	swap	d0
	and.w	#$000f,d0
	or.w	#$42c0,d0
	swap	d0
	bra	setSignFlag

HLtstbit15
	tst.w	d0
	bmi	maxbit47
maxbit46
	lsl.l	#6,d0	;64
	rol.l	#6,d1
	move.w	d1,d2
	and.w	#$ffc0,d1
	and.w	#$003f,d2
	or.w	d2,d0
	swap	d0
	or.w	#$42d0,d0
	swap	d0
	bra	setSignFlag
maxbit47
	lsl.l	#5,d0	;60
	rol.l	#5,d1
	move.w	d1,d2
	and.w	#$ffe0,d1
	and.w	#$001f,d2
	or.w	d2,d0
	swap	d0
	and.w	#$000f,d0
	or.w	#$42e0,d0
	swap	d0
	bra	setSignFlag
;
;  bit 48-63
;
cmpHi32Hi16
	cmp.w	#$00ff,d0
	bhi	HH16cmpbit12
	cmp.w	#$000f,d0
	bhi	HHcmpbit6
	cmp.w	#$0003,d0
	bhi	HHtstbit3

	btst	#1,d0
	bne	maxbit49
maxbit48
	move.w	#$042f,d0
	swap	d0
	lsl.l	#4,d0
	rol.l	#4,d1
	move.w	d1,d2
	and.w	#$fff0,d1
	and.w	#$000f,d2
	or.w	d2,d0
	bra	setSignFlag
maxbit49
	and.w	#$0001,d0
	or.w	#$0860,d0	;430
	swap	d0
	add.l	d1,d1	;48
	addx.l	d0,d0
	add.l	d1,d1
	addx.l	d0,d0
	add.l	d1,d1
	addx.l	d0,d0
	bra	setSignFlag

HHtstbit3
	btst	#3,d0
	bne	maxbit51
maxbit50
	and.w	#$0003,d0
	or.w	#$10c4,d0	;431
	swap	d0
	add.l	d1,d1
	addx.l	d0,d0
	add.l	d1,d1
	addx.l	d0,d0
	bra	setSignFlag
maxbit51
	and.w	#$0007,d0
	or.w	#$2190,d0	;432
	swap	d0
	add.l	d1,d1
	addx.l	d0,d0
	bra	setSignFlag

HHcmpbit6
	cmp.w	#$003f,d0
	bhi	HHtstbit7

	btst	#5,d0
	bne	maxbit53
maxbit52
	and.w	#$000f,d0
	or.w	#$4330,d0
	swap	d0
	bra	setSignFlag
maxbit53
	and.w	#$001f,d0
	or.w	#$8680,d0	;434
	swap	d0
	lsr.l	#1,d0
	roxr.l	#1,d1
	bra	setSignFlag

HHtstbit7
	btst	#7,d0
	bne	maxbit55
maxbit54
	swap	d0
	lsr.l	#1,d0
	roxr.l	#1,d1
	lsr.l	#1,d0
	roxr.l	#1,d1
	swap	d0
	or.w	#$4350,d0
	swap	d0
	bra	setSignFlag
maxbit55
	swap	d0
	move.w	d0,d2
	lsr.l	#3,d0
	and.w	#$0007,d2
	and.w	#$fff8,d1
	or.w	d2,d1
	ror.l	#3,d1
	swap	d0
	and.w	#$000f,d0
	or.w	#$4360,d0
	swap	d0
	bra	setSignFlag

HH16cmpbit12
	cmp.w	#$0fff,d0
	bhi	HHcmpbit14

	cmp.w	#$03ff,d0
	bhi	HHtstbit11

	btst	#9,d0
	bne	maxbit57
maxbit56
	swap	d0
	move.w	d0,d2
	lsr.l	#4,d0
	and.w	#$000f,d2
	and.w	#$fff0,d1
	or.w	d2,d1
	ror.l	#4,d1
	swap	d0
	or.w	#$4370,d0
	swap	d0
	bra	setSignFlag
maxbit57
	swap	d0
	move.w	d0,d2
	lsr.l	#5,d0
	and.w	#$001f,d2
	and.w	#$ffe0,d1
	or.w	d2,d1
	ror.l	#5,d1
	swap	d0
	and.w	#$000f,d0
	or.w	#$4380,d0
	swap	d0
	bra	setSignFlag

HHtstbit11
	btst	#11,d0
	bne	maxbit59
maxbit58
	swap	d0
	move.w	d0,d2
	lsr.l	#6,d0
	and.w	#$003f,d2
	and.w	#$ffc0,d1
	or.w	d2,d1
	ror.l	#6,d1
	swap	d0
	or.w	#$4390,d0
	swap	d0
	bra	setSignFlag
maxbit59
	swap	d0
	move.w	d0,d2
	lsr.l	#7,d0
	and.w	#$007f,d2
	and.w	#$ff80,d1
	or.w	d2,d1
	ror.l	#7,d1
	swap	d0
	and.w	#$000f,d0
	or.w	#$43a0,d0
	swap	d0
	bra	setSignFlag

HHcmpbit14
	cmp.w	#$3fff,d0
	bhi	HHtstbit15

	btst	#13,d0
	bne	maxbit61
maxbit60
	or.w	#$b000,d0
	swap	d0
	move.b	d0,d1
	move.b	#$43,d0
	ror.l	#8,d0
	ror.l	#8,d1
	bra	setSignFlag
maxbit61
	and.w	#$1fff,d0
	or.w	#$8000,d0
	swap	d0
	move.b	d0,d1
	move.b	#$87,d0
	ror.l	#8,d0
	ror.l	#8,d1
	lsr.l	#1,d0
	roxr.l	#1,d1
	bra	setSignFlag

HHtstbit15
	tst.w	d0
	bmi	maxbit63
maxbit62
	swap	d0
	move.w	d0,d2
	and.w	#$fc00,d0
	rol.l	#6,d0
	and.w	#$000f,d0
	or.w	#$43d0,d0
	swap	d0
	and.w	#$03ff,d2
	and.w	#$fc00,d1
	or.w	d2,d1
	rol.l	#6,d1
	swap	d1
	bra	setSignFlag
maxbit63
	swap	d0
	move.w	d0,d2
	and.w	#$f800,d0
	rol.l	#5,d0
	and.w	#$000f,d0
	or.w	#$43e0,d0
	swap	d0
	and.w	#$07ff,d2
	and.w	#$f800,d1
	or.w	d2,d1
	rol.l	#5,d1
	swap	d1
;
;@Zbg
;
setSignFlag
	move.l	a0,d2
	bpl	returnD0D1
	bset	#31,d0
returnD0D1
	rts

