;---------------------------------------
;	int/long ]Z
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even

;///////////////////////////////////////
;
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___modsi3
___modsi3
.if	MPU>=68020
	move.l	4(sp),d1
	divsl.l	8(sp),d0:d1
	rts
.else
	move.l	8(sp),d1
	beq	byzero
	move.l	4(sp),d0

	move.w	d1,a0
	cmp.l	d1,a0
	bne	modl

	move.w	d0,a0
	cmp.l	d0,a0
	bne	modl

	divs	d1,d0
	swap	d0
	ext.l	d0
	rts

modl
	tst.l	d1
	bmi	modm
	tst.l	d0
modpp
	bpl	umod
modmp
	neg.l	d0
	bsr	umod
	neg.l	d0
	rts
modm
	tst.l	d0
	bmi	modmm
modpm
	neg.l	d1
	bra	umod
modmm
	neg.l	d0
	neg.l	d1
	bsr	umod
	neg.l	d0
	rts

;////////////////////////////////////////////////////////////////
;

umodw
	move.l	d0,d2
	swap	d2
	cmp.w	d1,d2
	bcc	umodlw

umodww
	divu	d1,d0
	clr.w	d0
	swap	d0
	rts

umodlw
	move.l	d0,d2
	clr.w	d0
	swap	d0
	divu	d1,d0
	move.w	d2,d0
	divu	d1,d0
	clr.w	d0
	swap	d0
	rts

umodss
	swap	d0
	swap	d1
	divu	d1,d0
	clr.w	d0
	rts

byzero
	move.l	#$7fffffff,d0
	rts
zero
	moveq.l	#0,d0
ret
	rts
.endif

;////////////////////////////////////////////////////////////////
;
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___umodsi3
___umodsi3
.if	MPU>=68020
	move.l	4(sp),d1
	divul.l	8(sp),d0:d1
	rts
.else
	move.l	8(sp),d1
	beq	byzero
	move.l	4(sp),d0

;
;	d0.l %= d1.l
;
umod
	cmp.l	d0,d1
	beq	zero
	bhi	ret

	cmp.l	#$00010000,d1
	bcs	umodw

	move.w	d0,d2
	or.w	d1,d2
	beq	umodss

	move.l	d0,a1
	move.l	d1,a2
	cmp.l	#$01000000,d1
	bcc	msft16
msft8
	move.l	d1,d2
	swap	d2
	move.b	___libgnu_sfttbl(pc,d2.w),d2
	lsr.l	d2,d1
	lsr.l	d2,d0
	bra	div
msft16
	move.l	d1,d2
	swap	d2
	lsr.w	#8,d2
	move.b	___libgnu_sfttbl(pc,d2.w),d2
	addq.w	#8,d2
	lsr.l	d2,d1
	lsr.l	d2,d0
div
	divu	d1,d0
	move.w	d0,d2

	move.l	a2,d1
	mulu	d1,d2
	swap	d1
	mulu	d0,d1
	swap	d1
	clr.w	d1
	add.l	d1,d2
	move.l	a1,d0
	sub.l	d2,d0
	bpl	quit
	add.l	a2,d0
quit
	rts

	.even
___libgnu_sfttbl:
	dc.b	0		; 00
	dc.b	1		; 01
	dc.b	2		; 02
	dc.b	2		; 03
	dc.b	3		; 04
	dc.b	3		; 05
	dc.b	3		; 06
	dc.b	3		; 07
	dc.b	4		; 08
	dc.b	4		; 09
	dc.b	4		; 0a
	dc.b	4		; 0b
	dc.b	4		; 0c
	dc.b	4		; 0d
	dc.b	4		; 0e
	dc.b	4		; 0f
	dc.b	5		; 10
	dc.b	5		; 11
	dc.b	5		; 12
	dc.b	5		; 13
	dc.b	5		; 14
	dc.b	5		; 15
	dc.b	5		; 16
	dc.b	5		; 17
	dc.b	5		; 18
	dc.b	5		; 19
	dc.b	5		; 1a
	dc.b	5		; 1b
	dc.b	5		; 1c
	dc.b	5		; 1d
	dc.b	5		; 1e
	dc.b	5		; 1f
	dc.b	6		; 20
	dc.b	6		; 21
	dc.b	6		; 22
	dc.b	6		; 23
	dc.b	6		; 24
	dc.b	6		; 25
	dc.b	6		; 26
	dc.b	6		; 27
	dc.b	6		; 28
	dc.b	6		; 29
	dc.b	6		; 2a
	dc.b	6		; 2b
	dc.b	6		; 2c
	dc.b	6		; 2d
	dc.b	6		; 2e
	dc.b	6		; 2f
	dc.b	6		; 30
	dc.b	6		; 31
	dc.b	6		; 32
	dc.b	6		; 33
	dc.b	6		; 34
	dc.b	6		; 35
	dc.b	6		; 36
	dc.b	6		; 37
	dc.b	6		; 38
	dc.b	6		; 39
	dc.b	6		; 3a
	dc.b	6		; 3b
	dc.b	6		; 3c
	dc.b	6		; 3d
	dc.b	6		; 3e
	dc.b	6		; 3f
	dc.b	7		; 40
	dc.b	7		; 41
	dc.b	7		; 42
	dc.b	7		; 43
	dc.b	7		; 44
	dc.b	7		; 45
	dc.b	7		; 46
	dc.b	7		; 47
	dc.b	7		; 48
	dc.b	7		; 49
	dc.b	7		; 4a
	dc.b	7		; 4b
	dc.b	7		; 4c
	dc.b	7		; 4d
	dc.b	7		; 4e
	dc.b	7		; 4f
	dc.b	7		; 50
	dc.b	7		; 51
	dc.b	7		; 52
	dc.b	7		; 53
	dc.b	7		; 54
	dc.b	7		; 55
	dc.b	7		; 56
	dc.b	7		; 57
	dc.b	7		; 58
	dc.b	7		; 59
	dc.b	7		; 5a
	dc.b	7		; 5b
	dc.b	7		; 5c
	dc.b	7		; 5d
	dc.b	7		; 5e
	dc.b	7		; 5f
	dc.b	7		; 60
	dc.b	7		; 61
	dc.b	7		; 62
	dc.b	7		; 63
	dc.b	7		; 64
	dc.b	7		; 65
	dc.b	7		; 66
	dc.b	7		; 67
	dc.b	7		; 68
	dc.b	7		; 69
	dc.b	7		; 6a
	dc.b	7		; 6b
	dc.b	7		; 6c
	dc.b	7		; 6d
	dc.b	7		; 6e
	dc.b	7		; 6f
	dc.b	7		; 70
	dc.b	7		; 71
	dc.b	7		; 72
	dc.b	7		; 73
	dc.b	7		; 74
	dc.b	7		; 75
	dc.b	7		; 76
	dc.b	7		; 77
	dc.b	7		; 78
	dc.b	7		; 79
	dc.b	7		; 7a
	dc.b	7		; 7b
	dc.b	7		; 7c
	dc.b	7		; 7d
	dc.b	7		; 7e
	dc.b	7		; 7f
	dc.b	8		; 80
	dc.b	8		; 81
	dc.b	8		; 82
	dc.b	8		; 83
	dc.b	8		; 84
	dc.b	8		; 85
	dc.b	8		; 86
	dc.b	8		; 87
	dc.b	8		; 88
	dc.b	8		; 89
	dc.b	8		; 8a
	dc.b	8		; 8b
	dc.b	8		; 8c
	dc.b	8		; 8d
	dc.b	8		; 8e
	dc.b	8		; 8f
	dc.b	8		; 90
	dc.b	8		; 91
	dc.b	8		; 92
	dc.b	8		; 93
	dc.b	8		; 94
	dc.b	8		; 95
	dc.b	8		; 96
	dc.b	8		; 97
	dc.b	8		; 98
	dc.b	8		; 99
	dc.b	8		; 9a
	dc.b	8		; 9b
	dc.b	8		; 9c
	dc.b	8		; 9d
	dc.b	8		; 9e
	dc.b	8		; 9f
	dc.b	8		; a0
	dc.b	8		; a1
	dc.b	8		; a2
	dc.b	8		; a3
	dc.b	8		; a4
	dc.b	8		; a5
	dc.b	8		; a6
	dc.b	8		; a7
	dc.b	8		; a8
	dc.b	8		; a9
	dc.b	8		; aa
	dc.b	8		; ab
	dc.b	8		; ac
	dc.b	8		; ad
	dc.b	8		; ae
	dc.b	8		; af
	dc.b	8		; b0
	dc.b	8		; b1
	dc.b	8		; b2
	dc.b	8		; b3
	dc.b	8		; b4
	dc.b	8		; b5
	dc.b	8		; b6
	dc.b	8		; b7
	dc.b	8		; b8
	dc.b	8		; b9
	dc.b	8		; ba
	dc.b	8		; bb
	dc.b	8		; bc
	dc.b	8		; bd
	dc.b	8		; be
	dc.b	8		; bf
	dc.b	8		; c0
	dc.b	8		; c1
	dc.b	8		; c2
	dc.b	8		; c3
	dc.b	8		; c4
	dc.b	8		; c5
	dc.b	8		; c6
	dc.b	8		; c7
	dc.b	8		; c8
	dc.b	8		; c9
	dc.b	8		; ca
	dc.b	8		; cb
	dc.b	8		; cc
	dc.b	8		; cd
	dc.b	8		; ce
	dc.b	8		; cf
	dc.b	8		; d0
	dc.b	8		; d1
	dc.b	8		; d2
	dc.b	8		; d3
	dc.b	8		; d4
	dc.b	8		; d5
	dc.b	8		; d6
	dc.b	8		; d7
	dc.b	8		; d8
	dc.b	8		; d9
	dc.b	8		; da
	dc.b	8		; db
	dc.b	8		; dc
	dc.b	8		; dd
	dc.b	8		; de
	dc.b	8		; df
	dc.b	8		; e0
	dc.b	8		; e1
	dc.b	8		; e2
	dc.b	8		; e3
	dc.b	8		; e4
	dc.b	8		; e5
	dc.b	8		; e6
	dc.b	8		; e7
	dc.b	8		; e8
	dc.b	8		; e9
	dc.b	8		; ea
	dc.b	8		; eb
	dc.b	8		; ec
	dc.b	8		; ed
	dc.b	8		; ee
	dc.b	8		; ef
	dc.b	8		; f0
	dc.b	8		; f1
	dc.b	8		; f2
	dc.b	8		; f3
	dc.b	8		; f4
	dc.b	8		; f5
	dc.b	8		; f6
	dc.b	8		; f7
	dc.b	8		; f8
	dc.b	8		; f9
	dc.b	8		; fa
	dc.b	8		; fb
	dc.b	8		; fc
	dc.b	8		; fd
	dc.b	8		; fe
	dc.b	8		; ff
	.even
.endif
