;
;	src/mul0di.s: part of libgnu-1.50
;	Copyright 1994  씎Y(oo), HGG00736@niftyserve.or.jp
;
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

valueL	.reg	d0
valueH	.reg	d1
tempL	.reg	a0
tempH	.reg	d2

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.globl ___mul10di
___mul10di:
	move.l	4(sp),valueL
	move.l	8(sp),valueH
	bpl.s	___umul10di_exec

	neg.l	valueL
	negx.l	valueH
	bsr	___umul10di_exec
	neg.l	valueL
	negx.l	valueH
	rts

	.globl ___umul10di
___umul10di:
	move.l	4(sp),valueL
	move.l	8(sp),valueH

___umul10di_exec:
	add.l	valueL,valueL
	addx.l	valueH,valueH	* value*2
	move.l	valueL,tempL
	move.l	valueH,tempH

	add.l	valueL,valueL
	addx.l	valueH,valueH	* value*4
	add.l	valueL,valueL
	addx.l	valueH,valueH	* value*8

	add.l	tempL,valueL
	addx.l	tempH,valueH	* value*2 + value*8
	rts
	.end
