.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.xref	___builtin_new
	.xref	___mulsi3
	.xref	_write
	.xref	__exit

	.data
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.globl	___new_handler
___new_handler:
	.dc.l	_default_new_handler

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.globl	___builtin_vec_new
___builtin_vec_new:
	link	a6,#-12
	move.l	12(a6),d0
	addq.l	#1,d0
	move.l	d0,-8(a6)
	move.l	8(a6),d0
	bne	l4
.if	MPU>=68020
	move.l	-8(a6),d0
	mulu.l	16(a6),d0
.else
	move.l	-8(a6),-(sp)
	move.l	16(a6),-(sp)
.if	ALL_BSR
	bsr	___mulsi3
.else
	jsr	___mulsi3
.endif
	addq.w	#8,sp
*	move.l	16(a6),d1
*	movem.l	d0/d1,-(sp)
*	fpack	__CLMUL
*	movem.l	(sp)+,d0/d1
.endif
	move.l	d0,-(sp)
.if	ALL_BSR
	bsr	___builtin_new
.else
	jsr	___builtin_new
.endif
	addq.l	#4,sp
	move.l	d0,8(a6)
l4:
	move.l	8(a6),-12(a6)
	clr.l	-4(a6)
	bra	l5
l20001:
	move.l	8(a6),-(sp)
	move.l	20(a6),d0
	move.l	d0,a0
	jsr	(a0)
	addq.l	#4,sp
	move.l	16(a6),d0
	add.l	d0,8(a6)
l7:
	addq.l	#1,-4(a6)
l5:
	move.l	-4(a6),d0
	cmp.l	-8(a6),d0
	blt	l20001
	move.l	-12(a6),d0
	unlk	a6
	rts

	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.globl	___set_new_handler
___set_new_handler:
	link	a6,#-4
	move.l	___new_handler,-4(a6)
	move.l	8(a6),d0
	bne	l11
	move.l	#_default_new_handler,8(a6)
l11:
	move.l	8(a6),___new_handler
	move.l	-4(a6),d0
	unlk	a6
	rts

	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.globl	_set_new_handler
_set_new_handler:
	link	a6,#0
	move.l	8(a6),-(sp)
.if	ALL_BSR
	bsr	___set_new_handler
.else
	jsr	___set_new_handler
.endif
	addq.l	#4,sp
	unlk	a6
	rts

	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
_default_new_handler:
	link	a6,#0
	move.l	#65,-(sp)
	move.l	#l18,-(sp)
	move.l	#2,-(sp)
.if	ALL_BSR
	bsr	_write
.else
	jsr	_write
.endif
	lea	12(sp),sp
	move.l	#-1,-(sp)
.if	ALL_BSR
	bsr	__exit
.else
	jsr	__exit
.endif
	addq.l	#4,sp
l17:
	unlk	a6
	rts

	.data
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
l18:
	.dc.b	$64,$65,$66,$61,$75,$6c,$74,$5f,$6e,$65,$77,$5f,$68,$61
	.dc.b	$6e,$64,$6c,$65,$72,$3a,$20,$6f,$75,$74,$20,$6f,$66,$20,$6d
	.dc.b	$65,$6d,$6f,$72,$79,$2e,$2e,$2e,$20,$61,$61,$61,$69,$69,$69
	.dc.b	$69,$69,$69,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65
	.dc.b	$65,$65,$21,$0a,$00
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.end
