;
;	src/div10di.s: part of libgnu-1.50
;	Copyright 1994  씎Y(oo), HGG00736@niftyserve.or.jp
;
*
*	LIMIT0	si ł̌Z[vl
*	LIMIT	di ł̌Z[vl
*
LIMIT0	.equ	80			* < 128 łȂ΂ȂȂ
LIMIT	.equ	160			* < 0x8000 łȂ΂ȂȂ
					* 傫ƈZ̉񐔂ӂ

.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

.if	MPU<68020
	.xref	___udivsi3
.endif

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.globl ___div10di
___div10di:
	move.l	4(sp),d0
	move.l	8(sp),d1
.if	MPU<68020
	beq.s	___udiv10si		* == 0 ̏ꍇ si
	bpl.s	___udiv10di_exec	* > 0 ̏ꍇ͂̂܂
.else
	bpl.s	___udiv10di_0		* > 0 ̏ꍇ͂̂܂
.endif

	neg.l	d0			* < 0 ̏ꍇ͕]
	negx.l	d1
.if	MPU<68020
	tst.l	d1
	bne.s	@f
	bsr	___udiv10si
	bra.s	___div10di_end
@@:
	bsr	___udiv10di_exec
.else
	bsr	___udiv10di_0
.endif
___div10di_end:
	neg.l	d0			* ]
	negx.l	d1
	rts

.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.globl ___udiv10di
___udiv10di:

	move.l	4(sp),d0
	move.l	8(sp),d1		* di ǂ
.if	MPU<68020
	bne.s	___udiv10di_exec
.endif
___udiv10di_0:
.if	MPU>=68020
	moveq.l	#10,d2
	cmp.l	d2,d1
	bhs.s	___udiv10di_exec
.endif
___udiv10si:
.if	MPU>=68020
	tst.l	d1
	bne.s	___udiv10si_0
	cmp.l	#LIMIT0,d0
.else
	moveq.l	#LIMIT0,d1
	cmp.l	d1,d0
.endif
	bhi.s	___udiv10si_0

	move.l	d0,d1
	moveq.l	#0,d0
.if	MPU<68020
	moveq.l	#10,d2
.endif
___udiv10si_loop:
*	sub.l	d2,d1
	sub.b	d2,d1			* LIMIT0 < 256
	blo.s	___udiv10si_end
	addq.l	#1,d0
	bra.s	___udiv10si_loop

___udiv10si_0:
.if	MPU>=68020
	divu.l	d2,d1:d0
.else
	pea	10.w
	move.l	d0,-(sp)
.if	ALL_BSR
	bsr	___udivsi3		* si ̎͒ʏ퉉Z̕
.else
	jsr	___udivsi3		* si ̎͒ʏ퉉Z̕
.endif
	addq.l	#8,sp
.endif
___udiv10si_end:
	moveq.l	#0,d1			* ʃO[hNA
	rts

resultL	.reg	d0
resultH	.reg	d1
valueL	.reg	d2
valueH	.reg	d3
llL	.reg	d4
llH	.reg	d5
tempL	.reg	d6
tempH	.reg	d7
save6	.reg	a0
save7	.reg	a1
limit	.reg	a2

___udiv10di_exec:
*	movem.l	d3-d7,-(sp)
*	move.l 24(sp),valueL
*	move.l 28(sp),valueH
	movem.l d3-d5,-(sp)
	move.l	d6,save6
	move.l	d7,save7
	move.l d0,valueL
	move.l d1,valueH
	move.w	#LIMIT,limit
	moveq.l	#0,resultL
	moveq.l	#0,resultH

shift_loop:
*
*	while (value > 160LL) {
*
	tst.l	valueH
	bne.s	@F
	cmp.l	limit,valueL
	bls.s	shift_loop_end
@@:
*
*	ll = value >> 4;
*
	move.l	valueL,llL
	move.l	valueH,llH

	lsr.l	#1,llH		* 1
	roxr.l	#1,llL
	lsr.l	#1,llH		* 2
	roxr.l	#1,llL
	lsr.l	#1,llH		* 3
	roxr.l	#1,llL
	lsr.l	#1,llH		* 4
	roxr.l	#1,llL
*
*	ll += ll >> 1;
*
	move.l	llL,tempL
	move.l	llH,tempH
	lsr.l	#1,llH
	roxr.l	#1,llL
	add.l	tempL,llL
	addx.l	tempH,llH
*
*	result += ll;
*
	add.l	llL,resultL
	addx.l	llH,resultH
*
*	value -= ll*10;
*
	add.l	llL,llL		* ll*2
	addx.l	llH,llH
	move.l	llL,tempL
	move.l	llH,tempH
	add.l	llL,llL		* ll*4
	addx.l	llH,llH
	add.l	llL,llL		* ll*8
	addx.l	llH,llH
	add.l	tempL,llL
	addx.l	tempH,llH

	sub.l	llL,valueL
	subx.l	llH,valueH
	bra.s	shift_loop
*
*	}
*
shift_loop_end:
	moveq.l	#10,llL
inc_loop:
	sub.l	llL,valueL
	bcs.s	inc_loop_end
	addq.l	#1,resultL
	bcc.s	inc_loop
	addq.l	#1,resultH
	bra.s	inc_loop

inc_loop_end:
	move.l	save6,d6
	move.l	save7,d7
	movem.l (sp)+,d3-d5
*	movem.l (sp)+,d3-d7
	rts
	.end
