;---------------------------------------
;      int/long  double ^ϊ
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___floatsidf
___floatsidf
	move.l	4(sp),d0
	move.l	d0,a0		; reserve sign bit
	bpl	Normalize
	neg.l	d0

Normalize
	moveq.l	#0,d1		* patched(libc-1.1.32, libgnu.a)
	swap	d0
	tst.w	d0
	bne	cmpHi16
;
;  bit 0-15
;
cmpLow16
	swap	d0
	cmp.w	#$00ff,d0
	bhi	L16cmpbit12

	cmp.w	#$000f,d0
	bhi	Lcmpbit6
	cmp.w	#$0003,d0
	bhi	Ltstbit3

	cmp.w	#$0001,d0
	bhi	maxbit1
maxbit0
	bcs	returnD0D1	; is Zero
*	moveq.l	#0,d1		; is 1    patched(libc-1.1.32, libgnu.a)
	move.l	#$3ff00000,d0
	bra	setSignFlag
maxbit1
	moveq.l	#0,d1
	lsl.w	#3,d0
	and.w	#$000f,d0
	or.w	#$4000,d0
	swap	d0
	bra	setSignFlag

Ltstbit3
	btst	#3,d0
	bne	maxbit3
maxbit2
	moveq.l	#0,d1
	lsl.w	#2,d0
	or.w	#$4010,d0
	swap	d0
	bra	setSignFlag
maxbit3
	moveq.l	#0,d1
	add.w	d0,d0
	and.w	#$000f,d0
	or.w	#$4020,d0
	swap	d0
	bra	setSignFlag

Lcmpbit6
	cmp.w	#$003f,d0
	bhi	Ltstbit7

	btst	#5,d0
	bne	maxbit5
maxbit4
	moveq.l	#0,d1
	or.w	#$4030,d0
	swap	d0
	bra	setSignFlag
maxbit5
	moveq.l	#0,d1
	and.w	#$001f,d0
	or.w	#$8080,d0	;404
	swap	d0
	lsr.l	#1,d0
	bra	setSignFlag

Ltstbit7
	btst	#7,d0
	bne	maxbit7
maxbit6
	moveq.l	#0,d1
	ror.l	#2,d0
	or.w	#$4050,d0
	swap	d0
	bra	setSignFlag
maxbit7
	moveq.l	#0,d1
	ror.l	#3,d0
	and.w	#$000f,d0
	or.w	#$4060,d0
	swap	d0
	bra	setSignFlag

L16cmpbit12
	cmp.w	#$0fff,d0
	bhi	Lcmpbit14

	cmp.w	#$03ff,d0
	bhi	Ltstbit11

	btst	#9,d0
	bne	maxbit9
maxbit8
	moveq.l	#0,d1
	ror.l	#4,d0
	or.w	#$4070,d0
	swap	d0
	bra	setSignFlag
maxbit9
	moveq.l	#0,d1
	ror.l	#5,d0
	and.w	#$000f,d0
	or.w	#$4080,d0
	swap	d0
	bra	setSignFlag

Ltstbit11
	btst	#11,d0
	bne	maxbit11
maxbit10
	moveq.l	#0,d1
	ror.l	#6,d0
	or.w	#$4090,d0
	swap	d0
	bra	setSignFlag
maxbit11
	moveq.l	#0,d1
	ror.l	#7,d0
	and.w	#$000f,d0
	or.w	#$40a0,d0
	swap	d0
	bra	setSignFlag

Lcmpbit14
	cmp.w	#$3fff,d0
	bhi	Ltstbit15

	btst	#13,d0
	bne	maxbit13
maxbit12
	moveq.l	#0,d1
	ror.l	#8,d0
	or.w	#$40b0,d0
	swap	d0
	bra	setSignFlag
maxbit13
	moveq.l	#0,d1
	lsl.l	#7,d0
	swap	d0
	and.w	#$000f,d0
	or.w	#$40c0,d0
	swap	d0
	bra	setSignFlag

Ltstbit15
	tst.w	d0
	bmi	maxbit15
maxbit14
	moveq.l	#0,d1
	lsl.l	#6,d0
	swap	d0
	or.w	#$40d0,d0
	swap	d0
	bra	setSignFlag
maxbit15
	moveq.l	#0,d1
	lsl.l	#5,d0
	swap	d0
	and.w	#$000f,d0
	or.w	#$40e0,d0
	swap	d0
	bra	setSignFlag
;
; 16-31
;
cmpHi16
	cmp.w	#$00ff,d0
	bhi	H16cmpbit12

	cmp.w	#$000f,d0
	bhi	Hcmpbit6
	cmp.w	#$0003,d0
	bhi	Htstbit3

	btst	#1,d0
	bne	maxbit17
maxbit16
	moveq.l	#0,d1
	move.w	#$040f,d0
	swap	d0
	lsl.l	#4,d0
	bra	setSignFlag
maxbit17
	moveq.l	#0,d1
	rol.l	#3,d0
	and.w	#$000f,d0
	or.w	#$4100,d0
	swap	d0
	bra	setSignFlag

Htstbit3
	btst	#3,d0
	bne	maxbit19
maxbit18
	moveq.l	#0,d1
	rol.l	#2,d0
	or.w	#$4110,d0
	swap	d0
	bra	setSignFlag
maxbit19
	moveq.l	#0,d1
	rol.l	#1,d0
	and.w	#$000f,d0
	or.w	#$4120,d0
	swap	d0
	bra	setSignFlag

Hcmpbit6
	cmp.w	#$003f,d0
	bhi	Htstbit7

	btst	#5,d0
	bne	maxbit21
maxbit20
	moveq.l	#0,d1
	or.w	#$4130,d0
	swap	d0
	bra	setSignFlag
maxbit21
	moveq.l	#0,d1
	and.w	#$001f,d0
	or.w	#$8280,d0	;414
	swap	d0
	lsr.l	#1,d0
	roxr.l	#1,d1
	bra	setSignFlag

Htstbit7
	btst	#7,d0
	bne	maxbit23
maxbit22
	move.l	d0,d1
	moveq.l	#0,d0
	ror.l	#2,d1
	move.b	d1,d0
	or.w	#$4150,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit23
	move.l	d0,d1
	moveq.l	#0,d0
	ror.l	#3,d1
	move.b	d1,d0
	and.w	#$000f,d0
	or.w	#$4160,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag

H16cmpbit12
	cmp.w	#$0fff,d0
	bhi	Hcmpbit14

	cmp.w	#$03ff,d0
	bhi	Htstbit11

	btst	#9,d0
	bne	maxbit25
maxbit24
	move.l	d0,d1
	moveq.l	#0,d0
	ror.l	#4,d1
	move.b	d1,d0
	or.w	#$4170,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit25
	move.l	d0,d1
	moveq.l	#0,d0
	ror.l	#5,d1
	move.b	d1,d0
	and.w	#$000f,d0
	or.w	#$4180,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag

Htstbit11
	btst	#11,d0
	bne	maxbit27
maxbit26
	move.l	d0,d1
	moveq.l	#0,d0
	ror.l	#6,d1
	move.b	d1,d0
	or.w	#$4190,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit27
	move.l	d0,d1
	moveq.l	#0,d0
	ror.l	#7,d1
	move.b	d1,d0
	and.w	#$000f,d0
	or.w	#$41a0,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag

Hcmpbit14
	cmp.w	#$3fff,d0
	bhi	Htstbit15

	btst	#13,d0
	bne	maxbit29
maxbit28
	move.l	d0,d1
	moveq.l	#0,d0
	ror.l	#8,d1
	move.b	d1,d0
	or.w	#$41b0,d0
	clr.b	d1
	swap	d1
	swap	d0
	move.w	d1,d0
	clr.w	d1
	bra	setSignFlag
maxbit29
	swap	d0
	rol.l	#7,d0
	move.l	d0,d1
	and.w	#$ff80,d1
	and.w	#$000f,d0
	or.w	#$41c0,d0
	swap	d0
	swap	d1
	clr.w	d1
	bra	setSignFlag

Htstbit15
	tst.w	d0
	bmi	maxbit31
maxbit30
	swap	d0
	rol.l	#6,d0
	move.l	d0,d1
	and.w	#$ffc0,d1
	and.w	#$000f,d0
	or.w	#$41d0,d0
	swap	d0
	swap	d1
	clr.w	d1
	bra	setSignFlag
maxbit31
	swap	d0
	rol.l	#5,d0
	move.l	d0,d1
	and.w	#$ffe0,d1
	and.w	#$000f,d0
	or.w	#$41e0,d0
	swap	d0
	swap	d1
	clr.w	d1
	bra	setSignFlag
;
;@Zbg
;
setSignFlag
	move.l	a0,d2
	bpl	returnD0D1
	bset	#31,d0
returnD0D1
	rts

