;---------------------------------------
;  double  unsigned int/long ^ϊ
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___fixunsdfsi
___fixunsdfsi
	movem.l	4(sp),d0/d1
	move.l	d0,d2
	bmi	returnZero	; under flow
	or.l	d1,d2
	beq	returnZero	; double equal Zero
;
;	ƕo
;
	swap	d0
	move.w	d0,d2		; get exponent
	and.w	#$000f,d0	; get mantissa
	or.w	#$0010,d0
	swap	d0
;
;	w̌vZ
;
	and.w	#$7ff0,d2
	sub.w	#$3ff0,d2
	bmi	returnZero	; under flow
	lsr.w	#4,d2
	sub.w	#20,d2
	bmi	rightSft	; exponent lower then 24
	beq	returnD0	; no shift
	cmp.w	#11,d2
	bhi	returnMax	; over flow
;
;	Vtg
;
	move.w	d0,d1		; 1:2:3:4 -> d0=1:2 d1=2:3
	swap	d1

	lsl.l	d2,d0		; shift left
	lsl.l	d2,d1

	swap	d1
	move.w	d1,d0
	bra	returnD0

;
;	EVtg
;
rightSft
	neg.w	d2
	lsr.l	d2,d0

;
;	̕ϊ
;
returnD0
	rts

;
;	̑
;
returnZero
	moveq.l	#0,d0
	rts

returnMax
	moveq.l	#-1,d0
	rts

