;---------------------------------------
;@long long ^ _^ZpVtg
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___lshldi3
___lshldi3
	.xdef	___ashldi3
___ashldi3
	movem.l	4(sp),d0/d1/d2

	cmp.w	#2,d2
	bhi	leftSft3
	beq	leftSft2

leftSft1
	tst.w	d2		* for 0 bit shift
	beq.s	leftSft0	*
	lsl.l	#1,d0
	roxl.l	#1,d1
leftSft0
	rts

leftSft2
	lsl.l	#1,d0
	roxl.l	#1,d1
	lsl.l	#1,d0
	roxl.l	#1,d1
	rts

leftSft3
	cmp.w	#16,d2
	bhi	leftSft17
	beq	leftSft16

	move.l	d3,a0		; save register
	move.l	d0,d3		; 1:2:3:4 -> d1=1:2 d3=2:3 d0=3:4
	move.w	d1,d3
	swap	d3

	lsl.l	d2,d1		; right left 1:2
	lsl.l	d2,d3		; right left 2:3
	lsl.l	d2,d0		; right left 3:4

	swap	d3		; d1=1:2 d0=3:4
	move.w	d3,d1

	move.l	a0,d3		; restore register
	rts			*bra	returnD1D0

leftSft16
	swap	d0		; 1:2:3:4 -> d1=2:3 d0=4:0
	swap	d1
	move.w	d0,d1
	clr.w	d0
	rts			*bra	returnD1D0

leftSft17
	cmp.w	#32,d2
	bhi	leftSft33
	beq	leftSft32

	swap	d1		; 1:2:3:4 -> d1=2:3 d0=3:4
	swap	d0
	move.w	d0,d1
	swap	d0

	sub.w	#16,d2
	lsl.l	d2,d1
	lsl.l	d2,d0

	swap	d0		; d1=2:3 d0=3:4 -> d1=2:3 d0=4:0
	move.w	d0,d1
	clr.w	d0
	rts			*bra	returnD1D0

leftSft32
	move.l	d0,d1
	moveq.l	#0,d0
	rts			*bra	returnD1D0

leftSft33
	move.l	d0,d1
	moveq.l	#0,d0
	sub.w	#32,d2
	lsl.l	d2,d1

returnD1D0
	rts

