;---------------------------------------
;	float ^ Z
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

; Z̐x	 Prbg
;		w Wrbg
;		 QSrbgixRPrbgj
;

; ʂA_[t[ꍇAє񐳋K͂OƂȂ܂
; I[o[t[ꍇ͖Ԃ܂

;
;	Z
;
	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___mulsf3
___mulsf3
	movem.l	4(sp),d0/d1

	move.l	d3,a0
	move.l	d4,a1
;
;	wo
;
;	in:	d0.l	PxP
;		d1.l	PxQ
;
;	out:	d3.w	P̎wioCAX܂ށj
;		d4.w	Q̎wioCAX܂ށj
;
	move.w	#$7f80,d2
	move.l	d0,d3
	swap	d3
	and.w	d2,d3
	beq	returnZero
	move.l	d1,d4
	swap	d4
	and.w	d2,d4
	beq	returnZero
.if	0
	bne.s	calcExponent
quickReturnZero:
	move.l	a1,d4
	move.l	a0,d3
	moveq.l	#0,d0
	rts
.endif
calcExponent:
;
;	wvZ
;
;	in:	d3.w	wPioCAX܂ށj
;		d4.w	wQioCAX܂ށj
;
;	out:	d3.w	w̘aioCAX܂ށj
;			ŏʂɕrbg
;
	sub.w	#$3f80,d3	; sub exponent bias
	add.w	d4,d3
*	bvs	returnINF1	; exponent over flow
	bvc.s	calcSign
returnINF1
	move.l	a1,d4
	move.l	a0,d3
	eor.l	d0,d1
	move.l	#$ff000000,d0
	add.l	d1,d1
	roxr.l	#1,d0		; set sign bit
	rts

calcSign:
*	tst.w	d3
	ble	quickReturnZero	; exponent under flow (or denormalized)

	move.l	d0,d4		; reserve sign bit
	eor.l	d1,d4
	move.w	d3,d4
	move.l	d4,d3
;
;	o
;
;	in:	d0.l	PxP
;		d1.l	PxQ
;
;	out:	d0.l	P̉
;			 1.0000000000000000000000000000000
;		d1.l	Q̉
;			 1.0000000000000000000000000000000
;
	move.l	#$007fffff,d2
	and.l	d2,d0
	lsl.l	#8,d0
	bset	#31,d0

	and.l	d2,d1
	lsl.l	#8,d1
	bset	#31,d1
;
;	vZ
;
	move.l	d0,d2
	swap	d2
	mulu.w	d1,d2		; d1.low * d0.hi  d2.long
	swap	d1
	move.w	d1,d4
	mulu.w	d0,d4		; d4.hi * d0.low  d4.long
	clr.w	d4
	swap	d4
	clr.w	d2
	swap	d2
	add.l	d4,d2		; d2.long + d4.long  d2.long
	swap	d0
	mulu.w	d1,d0		; d1.hi * d0.hi  d0.long
	add.l	d2,d0
;
;	𐳋K
;
*	moveq.l	#0,d1
	tst.l	d0
*	bmi	rightSft8bit
	bpl	rightSft7bit

*	lsr.l	#7,d0
*	tst.w	d3
*	ble	returnZero	; exponent under flow (or denormalized)
*	bra	setExponent

rightSft8bit
	add.w	#$0080,d3
	bvs	returnINF2	; exponent over flow
	ble	returnZero	; exponent under flow (or denormalized)
	lsr.l	#1,d0
rightSft7bit:
	lsr.l	#7,d0
;
;	ƎwƉ̍
;
setExponent
	swap	d0
	and.w	#$007f,d0
	or.w	d3,d0
	tst.l	d3
	bpl	returnD0
	bset	#15,d0		; set sign bit
returnD0
	swap	d0
	move.l	a1,d4
	move.l	a0,d3
	rts

returnZero
	moveq.l	#0,d0
	move.l	a1,d4
	move.l	a0,d3
	rts

returnINF2
	move.l	#$ff000000,d0
	add.l	d4,d4
	roxr.l	#1,d0		; set sign bit
	move.l	a1,d4
	move.l	a0,d3
	rts
	.end
