;---------------------------------------
;	int/long ^ Z
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___mulsi3
___mulsi3
	.xdef	___umulsi3
___umulsi3
.if	MPU>=68020
	move.l	4(sp),d0
	mulu.l	8(sp),d0
	rts
.else
	move.l	4(sp),d0
	move.l	d0,d1
	swap	d1
	or.w	8(sp),d1
	bne	mulLong

	mulu.w	10(sp),d0
	rts

mulLong:
	move.l	8(sp),d1
	move.l	d3,a0
	move.l	d0,d2
	mulu.w	d1,d0		; d0.low * d1.low -> d0.l
	swap	d0		; result: low:high
	move.l	d2,d3
	swap	d3
	tst.w	d3		* check zero
	beq.s	@f
	mulu.w	d1,d3		; d0.hi  * d1.low
	add.w	d3,d0
@@:
	swap	d1
	tst.w	d1		* check zero
	beq.s	@f
	mulu.w	d2,d1		; d0.low * d1.hi
	add.w	d1,d0
@@:
	swap	d0
	move.l	a0,d3
	rts
.endif
	.end
