/*
 *	src/patchlevel.c: part of libgnu-1.50
 *	Copyright 1994  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	<stdio.h>


#ifndef	V
#define	V	146
#endif
#ifndef	P
#define	P	0
#endif
#ifndef	MPU
#define	MPU	68000
#endif

int main(void)
{
	FILE*	fp;

	if (fp = fopen("patchlevel.s", "w")) {
		fprintf(fp, "\t.text\n");
		fprintf(fp, "\t.even\n");
		fprintf(fp, ".if\tMPU>=68020\n");
		fprintf(fp, "\t.quad\n");
		fprintf(fp, ".endif\n");
		fprintf(fp, "\t.xdef\t___libgnu_patchlevel\n");
		fprintf(fp, "___libgnu_patchlevel:\n");
		fprintf(fp, "\tdc.b\t\'libgnu-%d.%d pl-%d for MC%d\',0\n", V/100, V%100, P, MPU);
		fprintf(fp, "\t.even\n");
		fprintf(fp, ".if\tMPU>=68020\n");
		fprintf(fp, "\t.quad\n");
		fprintf(fp, ".endif\n");
		fprintf(fp, "\t.end\n");
		fclose(fp);
		return 0;
	}
	fprintf(stderr, "cannot create patchlevel.s\n");
	return -1;
}
