;---------------------------------------
;	double  float ^ϊ
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

; ʂA_[t[ꍇAє񐳋K͂OƂȂ܂
; I[o[t[ꍇ͖Ԃ܂
; 񐔂̏ꍇ͔񐔂Ԃ܂

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___truncdfsf2
___truncdfsf2
	movem.l	4(sp),d0/d1
;
;	w
;
	swap	d0
	move.w	d0,d2
	and.w	#$7ff0,d2
	sub.w	#$3800,d2
	bls	returnSZero	; exponent under flow
	cmp.w	#$0ff0,d2
	bcc	returnINForNAN	; exponent over flow

	move.w	d0,d1		; get sign bit
	and.w	#$8000,d1
;
;	Ǝw̍
;
	and.w	#$000f,d0	; get mantissa (high word)
	or.w	d2,d0		; set exponent
	rol.l	#3,d0		; shift 3 bit
	or.w	d1,d0		; set sign bit
	swap	d0

	clr.w	d1		; get mantissa (low word)
	rol.l	#3,d1		; get lower 3bit
	or.w	d1,d0		; set mantissa (high word + low word)

	rts
;
;	̑
;
returnSZero
	swap	d0
	and.l	#$80000000,d0
	rts

returnINForNAN
	cmp.w	#$47f0,d2	; if exponent is NOT MAX then return INF
	bne	returnINF

	move.l	d0,d2
	and.l	#$ffff000f,d2
	or.l	d1,d2		; if mantissa is NOT ZERO then return NAN
	bne	returnNAN

returnINF
	and.w	#$8000,d0
	or.w	#$7f80,d0
	swap	d0
	clr.w	d0
	rts

returnNAN
	or.l	#$ffff7fff,d0
	swap	d0
	rts
